package immibis.ccperiphs;

/* $if jclient$ */

import net.minecraft.src.Block;
import net.minecraft.src.IBlockAccess;
import net.minecraft.src.RenderBlocks;
import net.minecraft.src.Tessellator;
import immibis.core.api.porting.PortableBlockRenderer;
import immibis.core.aspects.ClientOnly;

@ClientOnly
public class BlockRenderer implements PortableBlockRenderer {
	@Override
	public boolean renderWorldBlock(RenderBlocks render, IBlockAccess w, int x, int y, int z, Block block, int model) {
		TilePeriphs t = (TilePeriphs)w.getBlockTileEntity(x, y, z);
		if(t == null)
			return false;
		RenderUtils.renderBlockStatic(render, t.getBlockMetadata(), t, x, y, z);
		return true;
	}
	
	@Override
	public void renderInvBlock(RenderBlocks render, Block block, int meta, int model) {
		Tessellator.instance.startDrawingQuads();
		RenderUtils.renderBlockStatic(render, meta, null, -0.5, -0.5, -0.5);
		Tessellator.instance.draw();
		RenderUtils.renderInvBlock(render, meta);
	}
}

/* $endif$ */